import heapq

def cut_ropes(n, k):
    ropes = [-n]
    heapq.heapify(ropes)

    for _ in range(k):
        longest_rope = -heapq.heappop(ropes)

        if longest_rope % 2 == 0:
            heapq.heappush(ropes, -longest_rope // 2)
            heapq.heappush(ropes, -longest_rope // 2)
        else:
            heapq.heappush(ropes, -(longest_rope // 2))
            heapq.heappush(ropes, -(longest_rope // 2 + 1))

    return sorted([-rope for rope in ropes], reverse=True)

n = int(input())
k = int(input())
q = int(input())
queries = list(map(int, input().split()))

result = cut_ropes(n, k)

for query in queries:
    print(result[query - 1])
