def is_prime(n):
    if n <= 1:
        return False
    if n == 2:
        return True
    if n % 2 == 0:
        return False
    for i in range(3, int(n ** 0.5) + 1, 2):
        if n % i == 0:
            return False
    return True


def generate_cuts(n, current_cut=[], current_sum=0):
    if current_sum == n:
        yield current_cut
    elif current_sum < n:
        for i in range(1, n - current_sum + 1):
            if not is_prime(i):
                yield from generate_cuts(n, current_cut + [i], current_sum + i)


def difficult_cuts(n):
    for current_cut in generate_cuts(n):
        if all(current_cut[i] <= current_cut[i + 1] for i in range(len(current_cut) - 1)):
            print('+'.join(map(str, current_cut)))


n_input = int(input())
difficult_cuts(n_input)
