def get_prime_numbers(n):
    prime_numbers = []
    for i in range(2, n+1):
        is_prime = True
        for j in range(2, int(i**0.5) + 1):
            if i % j == 0:
                is_prime = False
                break
        if is_prime:
            prime_numbers.append(i)
    return prime_numbers

def get_nonprime_partitions(n):
    prime_numbers = get_prime_numbers(n)
    nonprime_partitions = []

    def backtrack(curr_partition, remaining):
        if remaining == 0:
            nonprime_partitions.append(curr_partition)
            return
        if remaining < 0:
            return
        if len(curr_partition) > 0 and curr_partition[-1] in prime_numbers:
            return
        
        for i in range(1, remaining+1):
            if len(curr_partition) == 0 or i >= curr_partition[-1]:
                if i not in prime_numbers:
                    backtrack(curr_partition + [i], remaining - i)

    backtrack([], n)
    return nonprime_partitions

n = int(input())
nonprime_partitions = get_nonprime_partitions(n)
for partition in nonprime_partitions:
    print("+".join(str(x) for x in partition))
