from sympy import primerange
def prime_partitions(n):
    primes = list(primerange(1, n + 1))
    partitions = []

    def backtrack(remain, current_partition, start_index):
        if remain == 0:
            partitions.append(current_partition)
            return

        for i in range(start_index, len(primes)):
            if remain < primes[i]:
                return
            backtrack(remain - primes[i], current_partition + [primes[i]], i)

    backtrack(n, [], 0)
    return partitions


n = int(input())
partitions = prime_partitions(n)
for partition in partitions:
    print('+'.join(map(str, partition)))