#include <iostream>
#include <vector>
#include <cmath>
 
typedef long long LL;
 
struct section
{
  LL
    Start,
    End;
};
 
int main( void )
{
  LL L, R;
 
  std::cin >> L;
  std::cin >> R;
 
  int n;
 
  std::cin >> n;
 
  std::vector<LL> DeltaTrees(n);
 
  for (int i = 0; i < n; i++)
    std::cin >> DeltaTrees[i];
 
  LL Pos = 0;
  std::vector<LL> TreesPos(n);
 
  for (int i = 0; i < n; i++)
  {
    Pos += DeltaTrees[i];
 
    TreesPos[i] = Pos;
  }
 
  std::vector<section> Variants;
   
  // From start
  for (int t = 0; t < n; t++)
    if (TreesPos[t] >= L && TreesPos[t] <= R)
      Variants.push_back({0, TreesPos[t]});
 
  // From tries
  
  int t = 0;

  while (TreesPos[t] < L && t < n)
    t++;

  bool IsFound = false;

  for (; t < n && !IsFound; t++)
    for (int s = 0; s < t; s++)
      if (TreesPos[t] - TreesPos[s] >= L && TreesPos[t] - TreesPos[s] <= R)
       {
         Variants.push_back({TreesPos[s], TreesPos[t]});
         IsFound = true;
         continue;
       }

  // int MinT = n;
 
  // for (int s = 0; s < MinT - L; s++) // - L
  //   for (int t = s + 1; t < MinT; t++)
  //     if (TreesPos[t] - TreesPos[s] >= L && TreesPos[t] - TreesPos[s] <= R)
  //     {
  //       Variants.push_back({TreesPos[s], TreesPos[t]});
  //       if (t < MinT)
  //         MinT = t;
  //     }
 
  if (Variants.empty())
  {
    std::cout << "-1 -1";
    return 0;
  }
 
  // Select by the end value
 
  std::vector<section> BetterVariants;
 
  for (int i = 0; i < (int)Variants.size(); i++)
    if (BetterVariants.empty())
      BetterVariants = {Variants[i]};
    else if (Variants[i].End == BetterVariants[0].End)
      BetterVariants.push_back(Variants[i]);
    else if ((Variants[i].End < BetterVariants[0].End))
      BetterVariants = {Variants[i]};
 
  // Select by the start value
 
  if (BetterVariants.size() == 1) // It can't be less then 1
    std::cout << BetterVariants[0].Start << " " << BetterVariants[0].End;
  else
  {
    section BestVariant = BetterVariants[0];
 
    for (int i = 1; i < (int)BetterVariants.size(); i++)
      if (BetterVariants[i].Start < BestVariant.Start)
        BestVariant = BetterVariants[i];
 
    std::cout << BestVariant.Start << " " << BestVariant.End;
  }
 
  return 0;
} 
 
 
/*
100
120
7
45
45
45
35
30
35
45
 
*/