#include <iostream>
#include <vector>
#include <map>

typedef unsigned long long ull;
typedef long long ll;
typedef unsigned int uint;

std::vector<int> S {2, 3, 5, 7, 11, 13, 17, 23};
std::map<ull, std::vector<std::vector<int>>> Razb;

bool CheckSimp( int n )
{
  for (auto a : S)
  {
    if (a == n)
      return true;
    if (n % a == 0)
      return false;
  }
  S.push_back(n);
  return true;
}

void PrintRazb( int n )
{
  auto &R = Razb[n];
  for (auto &Ri : R)
  {
    std::cout << Ri[0];
    for (int i = 1; i < Ri.size(); i++)
      std::cout << "+" << Ri[i];
    std::cout << std::endl;
  }
}

void EvalRazbRec( int n, std::vector<int> &CurR, int start )
{
  if (n == 0)
  {
    Razb[start].push_back(CurR);
    return;
  }
  if (n == 1)
  {
    CurR.push_back(1);
    Razb[start].push_back(CurR);
    return;
  }
  if (!Razb[n].empty())
    for (auto &R : Razb[n])
    {
      Razb[start].push_back(CurR);
      for (auto &i : R)
        Razb[start].back().push_back(i);
    }
  else 
  {
    if (!CheckSimp(n))
    {
      Razb[start].push_back(CurR);
      Razb[start].back().push_back(n);
    }
    CurR.push_back(1);
    EvalRazbRec(n - 1, CurR, start);
  }
}

void EvalRazb( int start )
{
  std::vector<int> R;
  if (Razb[start].empty())
  {
    R.push_back(1);
    EvalRazbRec(start - 1, R, start);
    if (!CheckSimp(start))
      Razb[start].push_back({start});
  }
  PrintRazb(start);
}

int main( void )
{
  int n;
  std::cin >> n;
  EvalRazb(n);
}