import heapq


def cut_ropes(n, k, queries):
    ropes = [-n]
    heapq.heapify(ropes)

    for _ in range(k):
        longest_rope = -heapq.heappop(ropes)
        if longest_rope % 2 == 0:
            heapq.heappush(ropes, -longest_rope // 2)
            heapq.heappush(ropes, -longest_rope // 2)
        else:
            heapq.heappush(ropes, -(longest_rope // 2))
            heapq.heappush(ropes, -(longest_rope // 2 + 1))

    result = sorted([-rope for rope in ropes], reverse=True)
    return [result[q - 1] for q in queries]


n = int(input(""))
k = int(input(""))
num_queries = int(input(""))
queries = list(map(int, input("").split()))

result = cut_ropes(n, k, queries)
print(" ".join(map(str, result)))