def partition(n, m):
    if n == 0:
        return [[]]
    if n < m or m == 0:
        return []
    with_m = partition(n - m, m)
    without_m = partition(n, m - 1)
    with_m = [([m] + sub) for sub in with_m]
    return with_m + without_m


def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num ** 0.5) + 1):
        if num % i == 0:
            return False
    return True


def non_prime_partitions(n):
    partitions = partition(n, n)
    result = []
    for p in partitions:
        if all(not is_prime(num) for num in p):
            result.append('+'.join(map(str, p)))
    return result


n = int(input())
result = non_prime_partitions(n)
for partition in result:
    print(partition)
    
