def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num**0.5) + 1):
        if num % i == 0:
            return False
    return True

def generate_partitions(n):
    def partition_helper(target, partial):
        if target == 0:
            partitions.append(list(partial))
            return
        for i in range(1, target + 1):
            if not is_prime(i):
                if not partial or i >= partial[-1]:
                    partial.append(i)
                    partition_helper(target - i, partial)
                    partial.pop()

    partitions = []
    partition_helper(n, [])
    return partitions

def print_partitions(n):
    partitions = generate_partitions(n)
    for partition in partitions:
        print(" + ".join(map(str, partition)))


n = int(input())
print_partitions(n)