#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    int numVersions;
    std::cout << "Enter the number of versions: ";
    std::cin >> numVersions;

    int numOperations;
    std::cout << "Enter the number of operations: ";
    std::cin >> numOperations;

    std::vector<int> versionLine(numVersions);
    for (int i = 0; i < numVersions; ++i) {
        std::cin >> versionLine[i];
    }

    int requests;
    std::cout << "Enter the number of requests: ";
    std::cin >> requests;

    std::vector<int> specialRequests(requests);
    for (int i = 0; i < requests; ++i) {
        std::cin >> specialRequests[i];
    }

    auto preprocess = [](int x) {
        int half = x / 2;
        if (x % 2 == 0) {
            return std::vector<int>{half, half};
        } else {
            return std::vector<int>{half, half + 1};
        }
    };

    int maxVersionLine = *std::max_element(versionLine.begin(), versionLine.end());

    std::vector<int> result;
    for (int i = 0; i < numOperations; ++i) {
        versionLine.erase(std::remove(versionLine.begin(), versionLine.end(), maxVersionLine), versionLine.end());
        versionLine.insert(versionLine.end(), preprocess(maxVersionLine));
        maxVersionLine = *std::max_element(versionLine.begin(), versionLine.end());
    }

    std::sort(versionLine.rbegin(), versionLine.rend());
    for (int i = 0; i < requests; ++i) {
        result.push_back(versionLine[specialRequests[i] - 1]);
    }

    std::cout << "Result: ";
    for (int version : result) {
        std::cout << version << " ";
    }
    std::cout << std::endl;

    return 0;
}
