def is_prime(num):
    """
    Функция для проверки, является ли число простым.
    """
    if num < 2:
        return False
    for i in range(2, int(num**0.5) + 1):
        if num % i == 0:
            return False
    return True


def non_prime_partitions(n):
    """
    Функция для генерации всех непростых разбиений числа n.
    """
    def backtrack(start, remaining, partition):
        # Если исчерпано количество оставшихся чисел для разбиения
        if remaining == 0:
            print('+'.join(map(str, partition)))
            return
          
        # Рекурсивно генерируем разбиения
        for i in range(start, remaining + 1):
            # Исключаем простые числа из разбиения
            if not is_prime(i):
                # Добавляем текущее число к разбиению
                partition.append(i)
                # Рекурсивно генерируем оставшуюся часть разбиения
                backtrack(i, remaining - i, partition)
                # Удаляем последний элемент, чтобы перейти к следующей итерации
                partition.pop()

    # Начинаем генерацию разбиений с первого числа и полного значения n
    backtrack(1, n, [])


# Пример использования
n = int(input())
non_prime_partitions(n)
