#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

/* ~~~~~ useful definitions ~~~~~ */
#define all(x) x.begin(), x.end()
#define mp make_pair
#define sz(x) (ll) x.size()
#define endl "\n"

/* ~~~~~ debug ~~~~~ */
#define printv(V) for (auto I : V) {cout << I << " ";} cout << endl;
#define debv(V) for (auto I : V) {cerr << I << " ";} cerr << endl;
#define deb(V) cerr << #V << " " << V << endl;
#define print2v(W) for (auto V : W) {printv(V)}

using namespace std;

/* ~~~~~ type definitions ~~~~~ */
using ll = long long;
using ld = long double;

/* ~~~~~ constants ~~~~~ */
const int INF = INT32_MAX;
const ll INFLL = INT64_MAX;
const ld EPS = 1e-6;
const ll MOD = 998244353;
const ld Pi = 3.141592653589793238462643383279;

/* ~~~~~~~~~~~~~~~ solution ~~~~~~~~~~~~~~~ */
#define int long long

int n;

void ppa(vector<int>&a, int k){
    for (int i = 0; i < k - 1; ++i) {
        cout << a[i] << "+";
    }
    cout << a[k - 1] << endl;
}

vector<int> prime = {0,0,1,1,0,1,0,1,0,0,0,1,0,1,0,0,0,1,0,1,0,0,0,1,0,0,0,0,0,1,0,1,0,0,0,0,0,1,0,0,0,1,0,1,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,1,0,1,0,0,0,0,0,1,0,0,0,};


bool is_prime(int n) {
    if (n < 2) return false;
    for (int i = 2; i * i <= n; ++i) {
        if (n % i == 0) return false;
    }
    return true;
}

void partition(int n) {
    vector<int> p(n + 1);
    int k = 1;
    p[1] = n;

    while (k != 0) {
        int x = p[k - 1] + 1;
        int y = p[k] - 1;
        k--;

        while (x <= y) {
            p[k] = x;
            y -= x;
            k++;
        }

        p[k] = x + y;

        if (all_of(p.begin(), p.begin() + k + 1, [](int i){ return !prime[i]; })) {
            ppa(p, k + 1);
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
    auto start_time = clock();
    cerr << setprecision(6) << fixed;
    cout << setprecision(12) << fixed;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << setprecision(16) << fixed;
#endif

    cin >> n;
    partition(n);

#ifdef LOCAL
    auto end_time = clock();
    cerr << "Execution time: " << (end_time - start_time) * (int) 1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}