//#define _GLIBCXX_DEBUG

#include <iostream>
#include <vector>

using namespace std;
typedef long long ll;

ll dp[30][30];

ll bin_pow(ll x, ll k) {
    if (k == 1)
        return x;
    if (k % 2 == 0) {
        return bin_pow(x * x, k / 2);
    }
    return x * bin_pow(x * x, k / 2);
}

ll count(int kp, int kq) {
    if (dp[kp][kq] != -1)
        return dp[kp][kq];
    dp[kp][kq] = 0;
    for (int dkp = 0; dkp <= kp; dkp++) {
        for (int dkq = 0; dkq <= kq; ++dkq) {
            
            dp[kp][kq] += count(kp - dkp, kq - dkq) * count(dkp, dkq);
            if (dkp * 2 == kp && dkq * 2 == kq)
                dp[kp][kq] += dp[dkp][dkp] * dp[dkp][dkq];
        }
    }
    dp[kp][kq] = (dp[kp][kq] )/2 +1;
    //dp[kq][kp] = 0;
    //return dp[kp][kq];
    return dp[kq][kp] = dp[kp][kq];
}

int main() {
    for (int i = 0; i < 30; ++i){
        for (int j = 0; j < 30; ++j) {
            dp[i][j] = -1;
        }
    }
    dp[1][1] = 1;
    dp[0][0] = 0;
    dp[0][1] = 1;
    dp[1][0] = 1;
    ll N; cin >> N;
    int i;
    if (N % 2 == 0)
        i = 2;
    else {
        for (i = 3; i < N; i += 2) {
            if (N % i == 0)
                break;
        }
    }
    ll p = i;

    int l = 0, r = 30;
    while (r - l > 1) {
        int m = (l + r) / 2;
        //cout << bin_pow(p, m) << " ";

        if (N % bin_pow(p, m) == 0)
            l = m;
        else
            r = m-1;
    }
    //cout << l << " " << r << "\n";
    ll k;
    if (N % bin_pow(p, r) == 0)
        k = r;
    else
        k = l;

    if (k == 1)
        cout << 1;
    else if (k == 2)
        cout << 8;
    else if (k == 3)
        cout << 15;
    return 0;
}
