﻿#include <iostream>
#include <vector>

void printLand(int n, int l) {
    if (n < l || n % 2 == 0 || l % 2 == 0) {
        std::cout << "Некорректные размеры, пожалуйста, убедитесь, что n >= l, n - нечетное, l - нечетное." << std::endl;
        return;
    }

    std::vector<std::vector<char>> land(n, std::vector<char>(n, '.')); // Создаем n*n землю

    // Перекресток в центре
    for (int i = 0; i < n; ++i) {
        land[n / 2][i] = '*'; // Горизонтальная часть перекрестка
        land[i][n / 2] = '*'; // Вертикальная часть перекрестка
    }

    // Дорога в середине земли
    int start = (n - l) / 2;
    for (int i = start; i < start + l; ++i) {
        land[i][n / 2] = '*'; // Вертикальная часть дороги
        land[n / 2][i] = '*'; // Горизонтальная часть дороги
    }

    // Выводим карту земли
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            std::cout << land[i][j] << " ";
        }
        std::cout << std::endl;
    }
}

int main() {
    int n, l;
    std::cout << "Введите размер земли (n): ";
    std::cin >> n;
    std::cout << "Введите размер дороги (l): ";
    std::cin >> l;

    printLand(n, l);

    return 0;
}